----------------------------------
-- MANAGING SUBPROGRAMS
----------------------------------

-- INFORMATION ABOUT SUBPROGRAMS IS STORED AND ACCESSED WITH DIFFERENT COMMANDS:

-- OBJECT INFORMATION -> USER_OBJECTS DICTIONARY VIEW

SELECT *
FROM USER_OBJECTS

SELECT *
FROM USER_OBJECTS
WHERE OBJECT_TYPE IN ('PROCEDURE','FUNCTION')
ORDER BY OBJECT_NAME

-- SOURCE CODE -> USER_SOURCE DICTIONARY VIEW

SELECT *
FROM USER_SOURCE

SELECT TEXT
FROM USER_SOURCE
WHERE NAME = 'ADD_JOB_HISTORY'
ORDER BY LINE;

SELECT TEXT
FROM USER_SOURCE
WHERE NAME = 'SECURE_DML'
ORDER BY LINE;


-- PARAMETERS -> DESCRIBE COMMAND

DESCRIBE ADD_JOB_HISTORY

DESCRIBE SECURE_DML

-- COMPILE ERRORS -> USER_ERRORS OR SHOW ERRORS COMMAND

SELECT * FROM USER_ERRORS;

-- EXAMPLE 1:
CREATE OR REPLACE PROCEDURE HR.PROC_TEST
IS
BEGIN
  X INT := 10;
END;

SELECT *
FROM USER_ERRORS
WHERE NAME = 'PROC_TEST'

SHOW ERRORS;


-- DEBUG INFORMATION CAN BE OBTAINED FROM THE PACKAGE DBMS_OUTPUT
